
User Interface - Bug #2893

Mouse clicks on rows are not 100% accurate

12/01/2015 05:34 PM - Stanislav Lomany

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Stanislav Lomany % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stabilization for GUI   

billable: No case_num:  

vendor_id: GCD   

Description

Related issues:

Related to User Interface - Feature #2564: implement GUI BROWSE widget Closed

History

#1 - 07/13/2016 03:26 PM - Stanislav Lomany

- Status changed from New to WIP

That is a general issue with AbstractWidget.translate(Widget<O>, MouseEvent). It also can be seen e.g. in radio sets. The returned value gets ~

+6/+6 relatively to the actual pointer position.

#2 - 07/13/2016 04:32 PM - Greg Shah

Could this be the same problem as described in #3142?

#3 - 07/13/2016 04:58 PM - Stanislav Lomany

Most likely it is.

#4 - 07/14/2016 03:02 PM - Stanislav Lomany

- File proper_position.png added

This screen illustrates what is the proper hot spot for Java2D and standard Ubuntu cursor. It is +1/+2 relatively to the very tip of the pointer.
https://proj.goldencode.com/issues/3142


#5 - 07/15/2016 10:56 AM - Stanislav Lomany

Created task branch 2893a from trunk revision 11069.

#6 - 07/15/2016 01:35 PM - Stanislav Lomany

The browse issue I've noted in the daily report is not an issue.

So please review task branch 2893a revision 11070.

#7 - 07/15/2016 02:31 PM - Greg Shah

- Start date deleted (12/01/2015)

- Target version set to Milestone 16

Code Review Task Branch 2893a Revision 11070

I'm OK with the change.

Hynek: please review.

#8 - 07/15/2016 05:02 PM - Hynek Cihlar

Code Review Task Branch 2893a Revision 11070.

The translation of parent's insets should be made only for BorderedPanelGuiImpl, see AbstractWidget.screenPhysicalLocation(). Otherwise the

change is OK.

#9 - 07/15/2016 05:13 PM - Greg Shah

The translation of parent's insets should be made only for BorderedPanelGuiImpl, see AbstractWidget.screenPhysicalLocation().

 

Please hide this knowledge in a method instead of doing an instanceof BorderedPanelGuiImpl on the parent.

#10 - 07/15/2016 05:25 PM - Hynek Cihlar

Greg Shah wrote:

The translation of parent's insets should be made only for BorderedPanelGuiImpl, see AbstractWidget.screenPhysicalLocation().

 

Please hide this knowledge in a method instead of doing an instanceof BorderedPanelGuiImpl on the parent.

 

Also, it would make sense to reuse screenPhysicalLocation() instead of duplicating the same logic in translate().
So instead of this:

      // get widget physical location wich is relative to it container. 

      NativePoint p = widget.physicalLocation();

      // get inner containers and calculate position

      Widget<O> parent = widget.parent();

      while (!(parent instanceof TopLevelWindow<?>))

      {

         p.translate(parent.physicalLocation());

         parent = parent.parent();

      }

      // mouse position relative to widget position

      return new NativePoint(evt.getX() - p.x, evt.getY() - p.y);

you would get this:

      NativePoint p = topLevelWindow().physicalLocation().translate(screenPhysicalLocation());

      // mouse position relative to widget position

      return new NativePoint(evt.getX() - p.x, evt.getY() - p.y);

The advantage is, aside from the code deduplication itself, that once the TODO is resolved in screenPhysicalLocation() it will not brake translate().

#11 - 07/18/2016 11:58 AM - Stanislav Lomany

translate function has two parameters:

translate(Widget<O> widget, MouseEvent evt)

In the new code the first parameter is not used. Considering that in practice this function always takes this as the first parameter, should I remove it?

#12 - 07/18/2016 11:59 AM - Stanislav Lomany
Also, should I skip regression testing because it is GUI-changes only?

#13 - 07/18/2016 01:27 PM - Greg Shah

In the new code the first parameter is not used. Considering that in practice this function always takes this as the first parameter, should I

remove it?

 

Yes.

Also, should I skip regression testing because it is GUI-changes only?

 

MAJIC testing can be skipped.  But the manual GUI testing will be very important.

#14 - 07/19/2016 04:58 PM - Stanislav Lomany

Task branch 2893a rebased from trunk rev 11071.

I did some GUI testing. Please review.

#15 - 07/19/2016 06:07 PM - Greg Shah

Code Review Task Branch 2893a Revision 11073

I'm fine with the changes.

Have you done enough manual GUI testing to confirm that this is safe to merge to trunk?

#16 - 07/19/2016 06:11 PM - Stanislav Lomany

I've checked testcases for widgets and menus and ran some customer GUI app scenarios.

#17 - 07/19/2016 06:11 PM - Greg Shah

OK, merge it to trunk.

#18 - 07/19/2016 07:24 PM - Stanislav Lomany

2893a was merged into the trunk as bzr revision 11072.

#19 - 07/19/2016 07:37 PM - Stanislav Lomany

- Status changed from WIP to Review
#20 - 07/19/2016 08:33 PM - Greg Shah

- % Done changed from 0 to 100

- Status changed from Review to Closed

#21 - 11/16/2016 12:22 PM - Greg Shah

- Target version changed from Milestone 16 to Cleanup and Stabilization for GUI
